unit haupt;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, ComCtrls, Spin, Menus, ExtCtrls, sqlite3conn, math, lcltype,
  //eigene
  audiofile, sammlung, playlist;

type

  { Tfrmhaupt }

  Tfrmhaupt = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    ProgressBar1: TProgressBar;
    ProgressBar2: TProgressBar;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    SpinEdit3: TSpinEdit;
    SpinEdit4: TSpinEdit;
    StatusBar1: TStatusBar;
    Timer1: TTimer;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure SpinEdit3Change(Sender: TObject);
    procedure SpinEdit4Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
  private
    { private declarations }
    procedure OnMPlay(Sender:TObject);
    procedure OnMPause(Sender:TObject);
    procedure OnMStop(Sender:TObject);
    procedure OnMResume(Sender:TObject);
    procedure OnMChange(Sender:TObject);
  public
    { public declarations }
    procedure LadeAllgEinstellungen;
    procedure AddDirToBiblio;
    procedure BiblioAnzeige;
    procedure InfoTextAkt(stext:string);
    procedure OnPlaylistAddItem(Sender:TObject; NewAudioFile:TAudioFile);
  end; 

var
  frmhaupt: Tfrmhaupt;

implementation

{ Tfrmhaupt }

procedure Tfrmhaupt.FormCreate(Sender: TObject);
begin
 smbdb := TSqlite3Connection.Create(nil);
 smbdb.DatabaseName := 'music.db';
 pldb := TSqlite3Connection.Create(nil);
 pldb.DatabaseName := 'playlist.db';
 smbpdb := TSqlite3Connection.Create(nil);
 smbpdb.DatabaseName := 'data.db';
 try
  smbpdb.Open;
  //Laden des Tagesprotokolls. Wenn Tbl nicht existent: Neu erstellen
 except
  ShowMessage('Verbindung zur data.db fehlgeschlagen. Es wird ein temporäres Protokoll erstellt und Standarteinstellungen geladen');
 end;
 try
  smbdb.Open;
  //Connect succesful in Protokoll schreiben
 except
  ShowMessage('Verbindung zur music.db fehlgeschlagen');
  //Connect faild in Protokoll schreiben
  close;
 end;
 try
  pldb.Open;
  //Connect succesful in Protokoll schreiben
 except
  ShowMessage('Verbindung zur music.db fehlgeschlagen');
  //Connect faild in Protokoll schreiben
  close;
 end;
 {$IFDEF UNIX}
  //Anfrage nach Basisfestplatte
 {$ENDIF}
 PCRegName := Computername;
 //BPlaylist Initialisieren
 BPlaylist := TPlaylist.Create;
 BPLaylist.InitBassEngine(Handle);
 BPlaylist.InitPlugins(ExtractFileDir(ParamStr(0)));
 BPlaylist.Volume    := (-1)*TrackBar2.Position/100;
 BPlaylist.OnPlay    := @OnMPlay;
 BPlaylist.OnResume  := @OnMResume;
 BPlaylist.OnPause   := @OnMPause;
 BPlaylist.OnStop    := @OnMStop;
 BPlaylist.OnChange  := @OnMChange;
 BPlaylist.OnAddItem := @OnPlaylistAddItem;
 BPlaylist.FadeIn    := 5000;
 BPlaylist.FadeOut   := 5000;
 BPlaylist.SetPan(0);
end;

procedure Tfrmhaupt.Button1Click(Sender: TObject);
begin
 case BPlaylist.BassStatus of
  0: begin
      BPlaylist.Play(-1,false);
      InfoTextAkt('');
     end;
  1: begin
      BPlaylist.Stop;
     end;
 end;
end;

procedure Tfrmhaupt.Button2Click(Sender: TObject);
begin
 case BPlaylist.BassStatus of
  1: begin
      BPlaylist.Pause;
     end;
  3: begin
      BPlaylist.Resume;
     end;
 end;
end;

procedure Tfrmhaupt.Button3Click(Sender: TObject);
begin
 BPlaylist.PlayPrevious;
 InfoTextAkt('');
end;

procedure Tfrmhaupt.Button4Click(Sender: TObject); //Next
begin
 BPlaylist.PlayNext(false);
 InfoTextAkt('');
end;

procedure Tfrmhaupt.Button5Click(Sender: TObject); //Fade
begin
 BPlaylist.PlayNext(true);
 InfoTextAkt('');
end;

procedure Tfrmhaupt.FormDestroy(Sender: TObject);
begin
 smbdb.Close; smbdb.Free;
 //music.db close in Protokoll schreiben
 pldb.Close; pldb.Free;
 //playlist.db close in Protokoll schreiben
 smbpdb.Close; smbpdb.Free;
end;

procedure Tfrmhaupt.MenuItem2Click(Sender: TObject);
begin
  close;
end;

procedure Tfrmhaupt.SpinEdit1Change(Sender: TObject);  //Fade In
begin
 BPlaylist.FadeIn := round(SpinEdit1.Value*1000);
end;

procedure Tfrmhaupt.SpinEdit2Change(Sender: TObject);  //Fade Out
begin
 BPlaylist.FadeOut := round(SpinEdit2.Value*1000);
end;

procedure Tfrmhaupt.SpinEdit3Change(Sender: TObject);  //Tempo
begin
 //Noch nicht integriert
end;

procedure Tfrmhaupt.SpinEdit4Change(Sender: TObject);  //Balance
begin
 BPlaylist.SetPan(SpinEdit4.Value/10);   //Defekt?? --> TESTEN
end;

procedure Tfrmhaupt.Timer1Timer(Sender: TObject);
var t:integer;
    Level,LLevel,RLevel:dword;
begin
 TrackBar1.Position := round(BPlaylist.Progress*100);
 t := round(BPlaylist.Time);
 label1.Caption := ' '+Format('%.2d:%.2d',[t div 60, t mod 60])+' ';
 Level := BPlaylist.GetChannelLevel;
 LLevel := trunc(LoWord(Level)/400);
 RLevel := trunc(HiWord(Level)/400);
 if BPlaylist.BassStatus = 1 then     //Sound spielt
 begin
  if round(BPlaylist.Time) > BPlaylist.PlayingFile.Dauer-(BPlaylist.FadeOut/1000) then
  begin
   BPlaylist.PlayNext(true);
   InfoTextAkt('');
  end;
 end;
 StatusBar1.Panels.Items[1].Text := DateTimeToStr(now);
end;

procedure Tfrmhaupt.TrackBar1Change(Sender: TObject);
begin
 BPlaylist.Progress := TrackBar1.Position/100;
end;

procedure Tfrmhaupt.TrackBar2Change(Sender: TObject);
begin
 BPlaylist.Volume := TrackBar2.Position/100*(-1);
end;

procedure Tfrmhaupt.LadeAllgEinstellungen;
begin

end;

procedure Tfrmhaupt.OnMPlay(Sender: TObject);
begin
 Timer1.Enabled := true;
 Button1.Caption := 'Stop';
 TrackBar1.Position := 0;
 //frmplaylisten.ListView1.Refresh;
end;

procedure Tfrmhaupt.OnMPause(Sender: TObject);
begin
 Timer1.Enabled := false;
 Button2.Caption := 'Weiter';
end;

procedure Tfrmhaupt.OnMStop(Sender: TObject);
begin
 Timer1.Enabled := false;
 Button1.Caption := 'Play';
 TrackBar1.Position := 0;
end;

procedure Tfrmhaupt.OnMResume(Sender: TObject);
begin
 Timer1.Enabled := true;
 Button2.Caption := 'Pause';
end;

procedure Tfrmhaupt.OnMChange(Sender: TObject);
begin
 InfoTextAkt('');
end;

procedure Tfrmhaupt.InfoTextAkt(stext: string);
begin

end;

procedure Tfrmhaupt.AddDirToBiblio;
begin

end;

procedure Tfrmhaupt.BiblioAnzeige;
begin

end;

procedure Tfrmhaupt.OnPlaylistAddItem(Sender: TObject; NewAudioFile: TAudioFile);
begin

end;

initialization
  {$I haupt.lrs}

end.

