unit playlisten;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  Menus, ComCtrls, ButtonPanel, ExtCtrls, StdCtrls, RTTICtrls, LCLType,
  //eigene
  audiofile, sammlung, haupt;

type

  { Tfrmplaylisten }

  Tfrmplaylisten = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ComboBox1: TComboBox;
    Edit1: TEdit;
    ListBox1: TListBox;
    ListBox2: TListBox;
    ListBox3: TListBox;
    ListBox4: TListBox;
    ListView1: TListView;
    ListView2: TListView;
    ListView3: TListView;
    ListView4: TListView;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem10: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem12: TMenuItem;
    MenuItem13: TMenuItem;
    MenuItem14: TMenuItem;
    MenuItem15: TMenuItem;
    MenuItem16: TMenuItem;
    MenuItem17: TMenuItem;
    MenuItem18: TMenuItem;
    MenuItem19: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem20: TMenuItem;
    MenuItem21: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    PageControl1: TPageControl;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    PopupMenu1: TPopupMenu;
    PopupMenu2: TPopupMenu;
    PopupMenu3: TPopupMenu;
    PopupMenu4: TPopupMenu;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListView1Click(Sender: TObject);
    procedure ListView1CustomDrawItem(Sender: TCustomListView; Item: TListItem;
      State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure ListView1DblClick(Sender: TObject);
    procedure ListView1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MenuItem3Click(Sender: TObject);
    procedure MenuItem4Click(Sender: TObject);
    procedure MenuItem5Click(Sender: TObject);
    procedure MenuItem6Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
    procedure MoveLVItem(LV: TListView; richtung:integer);
    procedure CopyListViewEntry(von, nach:TListView; index:integer);
  public
    { public declarations }
  end; 

var
  frmplaylisten: Tfrmplaylisten;

implementation

{ Tfrmplaylisten }

procedure Tfrmplaylisten.MoveLVItem(LV: TListView; richtung:integer);
var aItem, NextItem,TmpItem : TListItem;
begin
  with LV do
  begin
   if not Assigned(ItemFocused) then
      exit;//raus wenn Item editiert wird oder kein Item selektiert ist
    aItem := ItemFocused;
    case richtung of
      -1 : if aItem.Index = 0 then                            //abwärts
                  exit;//Erstes Item ist markiert > raus
      1 : if aItem.Index = Items.Count-1 then                //aufwärts
                  exit;//Letztes Item ist markiert > raus
    end;
    Nextitem := Items.Item[aItem.Index+richtung];
    Items.BeginUpdate;
    try
      TmpItem := TListItem.Create(Items);
      TmpItem.Assign(NextItem);
      NextItem.Assign(aItem);
      aItem.Assign(TmpItem);
      aItem.Selected := NextItem.Selected;
      TmpItem.Free;
      NextItem.MakeVisible(True);
      ItemFocused := NextItem;
      Selected := NextItem;
    finally
      Items.EndUpdate;
    end;
  end;
 aItem.Free;
 NextItem.Free;
 TmpItem.Free;
end;

procedure Tfrmplaylisten.CopyListViewEntry(von, nach: TListView; index: integer);
var newItem: TListItem;
begin
 newItem := nach.Items.Add;
 newItem.Caption := von.Items.Item[index].Caption;
 newItem.SubItems.Add(von.Items.Item[index].SubItems.Strings[0]);
 newItem.SubItems.Add(von.Items.Item[index].SubItems.Strings[1]);                 //Album
 newItem.SubItems.Add(von.Items.Item[index].SubItems.Strings[2]);
 newItem.SubItems.Add(von.Items.Item[index].SubItems.Strings[3]);        //Genre
 newItem.SubItems.Add(von.Items.Item[index].SubItems.Strings[4]);        //Kommentar
 newItem.SubItems.Add(von.Items.Item[index].SubItems.Strings[5]);
 newItem.Data := von.Items.Item[index].Data;
end;

procedure Tfrmplaylisten.Timer1Timer(Sender: TObject);
begin
 ListBox1.Width := round(panel3.Width/3);
 ListBox3.Width := ListBox1.Width;
 //Größe der Buttons in den Statusleisten anpassen
end;

procedure Tfrmplaylisten.FormCreate(Sender: TObject);
begin
 Timer1.Enabled := true;
end;

procedure Tfrmplaylisten.Button1Click(Sender: TObject);  //Wiedergabeliste speichern
begin

end;

procedure Tfrmplaylisten.Button2Click(Sender: TObject);  //Wiedergabeliste leeren
begin
 if MessageDlg('Wollen Sie den aktuellen Play wirklich leeren?', mtConfirmation, [mbYes, mbNo], 0)=mrYes then
 begin
  BPlaylist.Clear;
  ListView1.Clear;
 end;
end;

procedure Tfrmplaylisten.Button3Click(Sender: TObject);  //In Wiedergabeliste suchen
begin

end;

procedure Tfrmplaylisten.ListView1Click(Sender: TObject);
begin
 //frmLiedinfo aktualisieren
end;

procedure Tfrmplaylisten.ListView1CustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
begin
 if TAudioFile(Item.Data) = BPlaylist.PlayingFile then
 begin
  ListView1.Canvas.Font.Style := [fsBold];
  ListView1.Canvas.Font.Color := clgreen;
 end;
end;

procedure Tfrmplaylisten.ListView1DblClick(Sender: TObject);
begin
 BPlaylist.Play(ListView1.ItemFocused.Index, false);
 frmhaupt.InfoTextAkt('');
end;

procedure Tfrmplaylisten.ListView1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if shift=[] then
  case key of
   13: begin //Enter
        BPlaylist.Play(ListView1.ItemFocused.Index, false);
        frmhaupt.InfoTextAkt('');
       end;
   46: begin //Entf
        BPlaylist.RemoveTitel(ListView1.ItemFocused.Index);
        ListView1.Items.Delete(ListView1.ItemFocused.Index);
       end;
   VK_LEFT : BPlaylist.PlayPrevious;
   VK_RIGHT: BPlaylist.PlayNext(true);
   VK_ADD     : begin
                 BPlaylist.ChangeTitelPos(ListView1.ItemFocused.Index, 'up');
                 MoveLVItem(ListView1, 1);
                end;
   VK_SUBTRACT: begin
                 BPlaylist.ChangeTitelPos(ListView1.ItemFocused.Index, 'down');
                 MoveLVItem(ListView1, -1);
                end;
  end;
end;

procedure Tfrmplaylisten.MenuItem3Click(Sender: TObject);  //Wiedergabe leeren
begin
 Button2.Click;
end;

procedure Tfrmplaylisten.MenuItem4Click(Sender: TObject);  //Wiedergabetitel kopieren nach Playlisten
begin
 CopyListViewEntry(ListView1,ListView3,ListView1.ItemFocused.Index);
end;

procedure Tfrmplaylisten.MenuItem5Click(Sender: TObject);  //Wiedergabetitel kopieren nach Neue Liste
begin
 CopyListViewEntry(ListView1,ListView4,ListView1.ItemFocused.Index);
end;

procedure Tfrmplaylisten.MenuItem6Click(Sender: TObject);  //Wiedergabeliste speichern
begin
 Button1.Click;
end;

initialization
  {$I playlisten.lrs}

end.

